/* Implementation av berkningar av nollstlllen -- nollfunk.c */

#include <math.h>

float intervall(float x1, float x2, float (*f)(float), float e)
{
   float xm;

   do
   {
      xm = (x1 + x2) / 2;
      if ( f(xm)*f(x1) > 0 )
	      x1 = xm;
      else
	      x2 = xm;
   }
	while ( fabs(x2-x1) >= e);
	return xm;
}


float newton(float x1, float (*f)(float), float (*d)(float), float e)
{
   float x = x1 - f(x1) / d(x1);

   while ( fabs(x - x1) >= e )
   {
      x1 = x;
      x = x1 - f(x1)/d(x1);
   }
   return x;
}


float sekant(float x1, float x2, float (*f)(float), float e)
{
   float x = x2 - f(x2)*(x1 - x2) / (f(x1) -f(x2));

   while ( fabs(x - x2) >= e )
   {
      x1 = x2;
      x2 = x;
      x = x2 - f(x2)*(x1 - x2) /(f(x1) -f(x2));
   }
   return x;
}