/* Implementation av ppen hashtabell -- openhash.c */

#include "openhash.h"
#include <stdlib.h>

void initopenhash(datatyp *htab[])
{
   int i;

   for ( i = 0; i < HASHTABSIZE; i++)
      htab[i] = NULL;
}


void intoopenhash(datatyp *htab[], datatyp d,
		  int (*hashfunk)(datatyp))
{
   int index, hopp;

   index = hashfunk(d) % HASHTABSIZE;
   hopp = 1;

   while (htab[index] != NULL)
   {
      index = (index + hopp) % HASHTABSIZE;
      hopp += 2;
   }

   htab[index] = malloc(sizeof(datatyp));
   *htab[index] = d;
}

datatyp *searchopenhash(datatyp *htab[], datatyp nyckel,
			int (*hashfunk)(datatyp),
			int (*is_equal)(datatyp, datatyp))
{
   int index, hopp;


   index = hashfunk(nyckel) % HASHTABSIZE;
   hopp = 1;

   while (htab[index] != NULL && !is_equal(nyckel, *htab[index]))
   {
      index = ( index + hopp) % HASHTABSIZE;
      hopp += 2;
   }

   return htab[index];
}
