/* Implementation av sorteringsfunktioner -- sort.c */

#include "sort.h"

void ursort(datatyp v[], int nr, int (*comp)(datatyp, datatyp))
{
   int i, j, minelemi;
   datatyp temp;

   for (i = 0; i < nr - 1; i ++)
   {
      minelemi = i;
      for (j = i + 1; j < nr; j++)
      {
	      if ( comp(v[j], v[minelemi]))
	         minelemi = j;
      }
      temp = v[i];
      v[i] = v[minelemi];
      v[minelemi] = temp;
   }
}


void bubbsort(datatyp v[], int nr, int (*comp)(datatyp, datatyp))
{
   int i = 0, maxi = nr - 1, bubbel = 1;
   datatyp temp;

   while ( bubbel && maxi > 0)
   {
      bubbel = 0;
      for (i = 0; i < maxi; i++)
      {
	      if ( comp(v[i+1], v[i]) )
	      {
	         temp = v[i];
	         v[i] = v[i + 1];
	         v[i + 1] = temp;
	         bubbel = 1;
	      }
      }
      maxi--;
   }
}

void insort(datatyp v[], datatyp s[], int nr, int (*comp)(datatyp, datatyp))
{
   int i, j, klar;

   s[0] = v[0];
   for (i = 1; i < nr; i++)
   {
      klar = 0;
      j = i - 1;
      do
      {
	      if (comp(v[i], s[j]))
	      {
	         s[j+1] = s[j];
	         j--;
	      }
	      else
	      {
	         s[j+1] = v[i];
	         klar = 1;
	      }
      }
      while (!klar && j > -1);

      if (!klar)
	      s[0] = v[i];
   }
}
